#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define TAILLE_IMAGE 600
#define LARGEUR_IMAGE TAILLE_IMAGE*2
#define FALSE 1
#define TRUE 0
#define real float
#define PI 3.14159
#define AUTSIZE 200
#define VIDE 0
#define DEAD 19
#define WEST 4
#define EAST 6
#define SOUTH 2
#define NORTH 8
#define ROUGE 3
#define VERT 5
#define JAUNE 7
#define BLEU 9
#define BLANC 11
#define NOIR 25

#define MOVV 10
#define MOVW 14
#define MOVE 16
#define MOVS 12
#define MOVN 18
#define NCHG 20

// 0 = vide
// 4 = ouest
// 8 = nord
// 6 = est
// 2 = sud

// 10 = devient vide
// 14 = bouge  l'ouest
// 12 = bouge au sud
// 18 = bouge au nord
// 16 = bouge  l'est

// tab[i,j] := tab[i*AUTSIZE+j]

// on fait un peu de la dualit de l'automate cellulaire : c'est les dominos qui "bougent" 




// cette fonction dtruit les bad blocks et slide tout ce qu'il faut, la fonction qui remplit les trous est plus loin

char avenir_cellule(char tab[AUTSIZE*AUTSIZE], int i, int j)
{
	// on teste d'abord, peu importe o elle est, si elle est en contradiction avec une voisine
	
	// on suppose d'abord que (i,j) n'est pas sur les bords
	if(i!=0 && i!=AUTSIZE-1)
	{
		if(j!=0 && j!=AUTSIZE-1)
		{
			// si cette cellule est en contradiction avec une voisine, elle devient vide :
			
			// si cette cellule est EAST et que sa voisine droite est WEST, elle devient vide
			if(tab[i*AUTSIZE+j] == EAST && tab[(i+1)*AUTSIZE+j] == WEST)
			return MOVV;
			
			// si cette cellule est NORTH et que sa voisine du dessus est SOUTH, elle devient vide
			if(tab[i*AUTSIZE+j] == NORTH && tab[i*AUTSIZE+j+1] == SOUTH)
			return MOVV;
			
			// si cette cellule est WEST et que sa voisine de gauche est EAST, elle devient vide
			if(tab[i*AUTSIZE+j] == WEST && tab[(i-1)*AUTSIZE+j] == EAST)
			return MOVV;
			
			// si cette cellule est SOUTH et que sa voisine du dessous est NORTH, elle devient vide
			if(tab[i*AUTSIZE+j] == SOUTH && tab[i*AUTSIZE+j-1] == NORTH)
			return MOVV;
		}
	}
	
	// maintenant, si la cellule est sur les bords...
	
	if(i==0)
	{
		// si elle est sur le bord gauche et en contradiction avec une voisine, elle devient vide :
		
		if(j!=0 && j!=AUTSIZE-1)
		{
			// si elle est pas dans un coin, elle a trois voisines
		
			// si cette cellule est EAST et que sa voisine droite est WEST, elle devient vide
			if(tab[i*AUTSIZE+j] == EAST && tab[(i+1)*AUTSIZE+j] == WEST)
			return MOVV;
			
			// si cette cellule est NORTH et que sa voisine du dessus est SOUTH, elle devient vide
			if(tab[i*AUTSIZE+j] == NORTH && tab[i*AUTSIZE+j+1] == SOUTH)
			return MOVV;
			
			// cette cellule n'a pas de voisine de gauche avec qui tre en contradiction
			
			// si cette cellule est SOUTH et que sa voisine du dessous est NORTH, elle devient vide
			if(tab[i*AUTSIZE+j] == SOUTH && tab[i*AUTSIZE+j-1] == NORTH)
			return MOVV;
		}
		else
		{
			if(j==0)
			{
				// sinon, si elle est dans le coin en bas  gauche, elle a une voisine de droite et une du dessus
				
				// si cette cellule est EAST et que sa voisine droite est WEST, elle devient vide
				if(tab[i*AUTSIZE+j] == EAST && tab[(i+1)*AUTSIZE+j] == WEST)
				return MOVV;
				
				// si cette cellule est NORTH et que sa voisine du dessus est SOUTH, elle devient vide
				if(tab[i*AUTSIZE+j] == NORTH && tab[i*AUTSIZE+j+1] == SOUTH)
				return MOVV;
				
				// cette cellule n'a pas de voisine de gauche avec qui tre en contradiction
				
				// cette cellule n'a pas de voisine du bas avec qui tre en contradiction
			}
			
			if(j==AUTSIZE-1)
			{
				// sinon, si elle est dans le coin en haut  gauche, elle a une voisine de droite et une du dessous
				
				// si cette cellule est EAST et que sa voisine droite est WEST, elle devient vide
				if(tab[i*AUTSIZE+j] == EAST && tab[(i+1)*AUTSIZE+j] == WEST)
				return MOVV;
				
				// cette cellule n'a pas de voisine du dessus
				
				// cette cellule n'a pas de voisine de gauche
				
				// si cette cellule est SOUTH et que sa voisine du dessous est NORTH, elle devient vide
				if(tab[i*AUTSIZE+j] == SOUTH && tab[i*AUTSIZE+j-1] == NORTH)
				return MOVV;
				
			}
		}
	}
	else
	{
		// sinon elle est sur le bord droit et si elle est en contradiction avec une voisine, elle devient vide :
		
		if(j!=0 && j!=AUTSIZE-1)
		{
			// si elle est pas dans un coin, elle a trois voisines
		
			// cette cellule n'a pas de voisine de droite
			
			// si cette cellule est WEST et que sa voisine de gauche est EAST, elle devient vide
			if(tab[i*AUTSIZE+j] == WEST && tab[(i-1)*AUTSIZE+j] == EAST)
			return MOVV;
			
			// si cette cellule est NORTH et que sa voisine du dessus est SOUTH, elle devient vide
			if(tab[i*AUTSIZE+j] == NORTH && tab[i*AUTSIZE+j+1] == SOUTH)
			return MOVV;
			
			// si cette cellule est SOUTH et que sa voisine du dessous est NORTH, elle devient vide
			if(tab[i*AUTSIZE+j] == SOUTH && tab[i*AUTSIZE+j-1] == NORTH)
			return MOVV;
		}
		else
		{
			if(j==0)
			{
				// sinon, si elle est dans le coin en bas  droite, elle a une voisine de gauche et une de dessus
				
				// si cette cellule est WEST et que sa voisine gauche est EAST, elle devient vide
				if(tab[i*AUTSIZE+j] == WEST && tab[(i-1)*AUTSIZE+j] == EAST)
				return MOVV;
				
				// si cette cellule est NORTH et que sa voisine du dessus est SOUTH, elle devient vide
				if(tab[i*AUTSIZE+j] == NORTH && tab[i*AUTSIZE+j+1] == SOUTH)
				return MOVV;
				
				// cette cellule n'a pas de voisine de droite avec qui tre en contradiction
				
				// cette cellule n'a pas de voisine du bas avec qui tre en contradiction
			}
			
			if(j==AUTSIZE-1)
			{
				// sinon, si elle est dans le coin en haut  droite, elle a deux voisines, une de gauche et une dessous
				
				// si cette cellule est WEST et que sa voisine gauche est EAST, elle devient vide
				if(tab[i*AUTSIZE+j] == WEST && tab[(i-1)*AUTSIZE+j] == EAST)
				return MOVV;
				
				// cette cellule n'a pas de voisine du dessus
				
				// cette cellule n'a pas de voisine de droite
				
				// si cette cellule est SOUTH et que sa voisine du dessous est NORTH, elle devient vide
				if(tab[i*AUTSIZE+j] == SOUTH && tab[i*AUTSIZE+j-1] == NORTH)
				return MOVV;
			}
		}
	}
	
	// maintenant qu'on est sr qu'elle n'est pas en contradiction avec une voisine, on lui donne le dsir de bouger conformment  son tat
	
	if(tab[i*AUTSIZE+j] == EAST)
	return MOVE;
	
	if(tab[i*AUTSIZE+j] == NORTH)
	return MOVN;
	
	if(tab[i*AUTSIZE+j] == WEST)
	return MOVW;
	
	if(tab[i*AUTSIZE+j] == SOUTH)
	return MOVS;
}






void destroy(char result[AUTSIZE*AUTSIZE], char tab[AUTSIZE*AUTSIZE])
{
	int i;
	int j;
	
	// on commence par tout copier
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			result[i*AUTSIZE+j] = tab[i*AUTSIZE+j];
		}
	}
	
	// maintenant, toute cellule non vide va tre considre comme morte
	
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			if(tab[i*AUTSIZE+j] != VIDE)
			{
				result[i*AUTSIZE+j] = DEAD;
			}
		}
	}
	
	
	// ensuite on va appliquer tous les changements
	
	// toutes celles qui veulent mourir, on les tue
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			if(avenir_cellule(tab,i,j) == MOVV)
			{
				result[i*AUTSIZE+j] = DEAD;
			}
		}
	}
}

void slide(char result[AUTSIZE*AUTSIZE], char tab[AUTSIZE*AUTSIZE])
{
	int i,j;
	
	// et les autres on les bouge
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			// si la cellule a le dsir d'aller  l'ouest on dit  celle  sa gauche de devenir ouest sauf si c'est au bord
			
			if(avenir_cellule(tab,i,j) == MOVW && i!= 0)
			{
				result[(i-1)*AUTSIZE+j] = WEST;
			}
			
			// si la cellule a le dsir d'aller  l'est on dit  celle  sa droite de devenir est sauf si c'est au bord
			
			if(avenir_cellule(tab,i,j) == MOVE && i!= AUTSIZE-1)
			{
				result[(i+1)*AUTSIZE+j] = EAST;
			}
			
			// si la cellule a le dsir d'aller au sud on dit  celle dessous de devenir sud sauf si c'est au bord
			
			if(avenir_cellule(tab,i,j) == MOVS && j!= 0)
			{
				result[i*AUTSIZE+j-1] = SOUTH;
			}
			
			// si la cellule a le dsir d'aller au nord (bien plus au nord) on dit  celle du dessus de devenir nord sauf si c'est au bord
			
			if(avenir_cellule(tab,i,j) == MOVN && j!= AUTSIZE-1)
			{
				result[i*AUTSIZE+j+1] = NORTH;
			}
		}
	}
	
	// une fois que result est prt, on remplace tab par result
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			tab[i*AUTSIZE+j] = result[i*AUTSIZE+j];
		}
	}
}

void remplace(char result[AUTSIZE*AUTSIZE], char tab[AUTSIZE*AUTSIZE])
{
	int i,j;
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			tab[i*AUTSIZE+j] = result[i*AUTSIZE+j];
		}
	}
}

void initialise(char tab[AUTSIZE*AUTSIZE])
{
	int i,j;
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			tab[i*AUTSIZE+j] = VIDE;
		}
	}
}




















/*
void destroy_slide(char tab[AUTSIZE*AUTSIZE])
{
	char result[AUTSIZE*AUTSIZE];
	int i;
	int j;
	
	// on commence par tout remplir de vide
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			result[i*AUTSIZE+j] = VIDE;
		}
	}
	
	// maintenant, toute cellule non vide va tre considre comme morte
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			if(tab[i*AUTSIZE+j] != VIDE)
			{
				result[i*AUTSIZE+j] = DEAD;
			}
		}
	}
	
	// ensuite on va appliquer tous les changements
	
	// toutes celles qui veulent mourir, on les tue
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			if(avenir_cellule(tab,i,j) == MOVV)
			{
				result[i*AUTSIZE+j] = DEAD;
			}
		}
	}
	
	// et les autres on les bouge
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			// si la cellule a le dsir d'aller  l'ouest on dit  celle  sa gauche de devenir ouest sauf si c'est au bord
			
			if(avenir_cellule(tab,i,j) == MOVW && i!= 0)
			{
				result[(i-1)*AUTSIZE+j] = WEST;
			}
			
			// si la cellule a le dsir d'aller  l'est on dit  celle  sa droite de devenir est sauf si c'est au bord
			
			if(avenir_cellule(tab,i,j) == MOVE && i!= AUTSIZE-1)
			{
				result[(i+1)*AUTSIZE+j] = EAST;
			}
			
			// si la cellule a le dsir d'aller au sud on dit  celle dessous de devenir sud sauf si c'est au bord
			
			if(avenir_cellule(tab,i,j) == MOVS && j!= 0)
			{
				result[i*AUTSIZE+j-1] = SOUTH;
			}
			
			// si la cellule a le dsir d'aller au nord (bien plus au nord) on dit  celle du dessus de devenir nord sauf si c'est au bord
			
			if(avenir_cellule(tab,i,j) == MOVN && j!= AUTSIZE-1)
			{
				result[i*AUTSIZE+j+1] = NORTH;
			}
		}
	}
	
	// une fois que result est prt, on remplace tab par result
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			tab[i*AUTSIZE+j] = result[i*AUTSIZE+j];
		}
	}
}
*/

// la fonction suivante est cense renvoyer true si la cellule (i,j) est le coin infrieur gauche d'un good block vide de bordure

char is_good_block(char tab[AUTSIZE*AUTSIZE], int i, int j)
{
	// si la cellule touche un bord, il n'y a pas de bloc du tout !
	
	if(i==AUTSIZE-1 || j==AUTSIZE-1)
	return FALSE;
	
	// sinon, a touche pas le bord
	
	// si c'est au bord la good block contient des vides et des mortes
	
	if(tab[i*AUTSIZE+j] == DEAD && tab[i*AUTSIZE+j+1] == DEAD && tab[(i+1)*AUTSIZE+j] == VIDE && tab[(i+1)*AUTSIZE+j+1] == VIDE)
	return TRUE;
	
	if(tab[i*AUTSIZE+j] == DEAD && tab[i*AUTSIZE+j+1] == VIDE && tab[(i+1)*AUTSIZE+j] == DEAD && tab[(i+1)*AUTSIZE+j+1] == VIDE)
	return TRUE;
	
	if(tab[i*AUTSIZE+j] == VIDE && tab[i*AUTSIZE+j+1] == DEAD && tab[(i+1)*AUTSIZE+j] == VIDE && tab[(i+1)*AUTSIZE+j+1] == DEAD)
	return TRUE;
	
	if(tab[i*AUTSIZE+j] == VIDE && tab[i*AUTSIZE+j+1] == VIDE && tab[(i+1)*AUTSIZE+j] == DEAD && tab[(i+1)*AUTSIZE+j+1] == DEAD)
	return TRUE;
	
	if(tab[i*AUTSIZE+j] == DEAD && tab[i*AUTSIZE+j+1] == DEAD && tab[(i+1)*AUTSIZE+j] == DEAD && tab[(i+1)*AUTSIZE+j+1] == VIDE)
	return TRUE;
	
	if(tab[i*AUTSIZE+j] == DEAD && tab[i*AUTSIZE+j+1] == VIDE && tab[(i+1)*AUTSIZE+j] == DEAD && tab[(i+1)*AUTSIZE+j+1] == DEAD)
	return TRUE;
	
	if(tab[i*AUTSIZE+j] == VIDE && tab[i*AUTSIZE+j+1] == DEAD && tab[(i+1)*AUTSIZE+j] == DEAD && tab[(i+1)*AUTSIZE+j+1] == DEAD)
	return TRUE;
	
	if(tab[i*AUTSIZE+j] == DEAD && tab[i*AUTSIZE+j+1] == DEAD && tab[(i+1)*AUTSIZE+j] == VIDE && tab[(i+1)*AUTSIZE+j+1] == DEAD)
	return TRUE;
	
	// testons si les cellules dans le bloc sont bien MORTES, sinon on sait qu'on renvoie false
	if(tab[i*AUTSIZE+j] != DEAD || tab[(i+1)*AUTSIZE+j] != DEAD || tab[i*AUTSIZE+j+1] != DEAD || tab[(i+1)*AUTSIZE+j+1] != DEAD)
	return FALSE;
	
	// le bloc est bien mort
	
	// pour savoir si le bloc est de bordure, on teste si ya quelque chose dans un coin du bloc
	
	// on ne prend pas de prcautions si i=0 ou j=0...
	
	if((tab[(i-1)*AUTSIZE+j] != DEAD || tab[(i-1)*AUTSIZE+j+1] != DEAD) && (tab[i*AUTSIZE+j-1] != DEAD || tab[(i+1)*AUTSIZE+j-1] != DEAD))
	return TRUE;
	
	if((tab[(i-1)*AUTSIZE+j] != DEAD || tab[(i-1)*AUTSIZE+j+1] != DEAD) && (tab[i*AUTSIZE+j+2] != DEAD || tab[(i+1)*AUTSIZE+j+2] != DEAD))
	return TRUE;
	
	if((tab[(i+2)*AUTSIZE+j] != DEAD || tab[(i+2)*AUTSIZE+j+1] != DEAD) && (tab[i*AUTSIZE+j-1] != DEAD || tab[(i+1)*AUTSIZE+j-1] != DEAD))
	return TRUE;
	
	if((tab[(i+2)*AUTSIZE+j] != DEAD || tab[(i+2)*AUTSIZE+j+1] != DEAD) && (tab[i*AUTSIZE+j+2] != DEAD || tab[(i+1)*AUTSIZE+j+2] != DEAD))
	return TRUE;
	
	// bon ben c'est que c'est un bloc mort mais qui est pas dans un coin donc on sait pas encore si c'est un good block  remplir
	
	return FALSE;
}

int randbit(void)
{
   static int first = 0;
   
   if (first == 0)
   {
      srand (time (NULL));
      first = 1;
   }
   return ((int)(rand() / (double)RAND_MAX * 2));
}

// la fonction suivante va combler les trous  distance au plus d du centre

void create_good_block(char tab[AUTSIZE*AUTSIZE], int d)
{
	int i,j;
	int x,y;
	int b;
	
	for(x=-d;x<=d;x++)
	{
		for(y=-d;y<=d;y++)
		{
			if(abs(x)%2 == d%2 && abs(y)%2 == d%2 && abs(x)%2 == abs(y)%2)
			{
				i = (int)((0.5)*(float)(x+y)+AUTSIZE/2-1);
				j = (int)((0.5)*(float)(y-x)+AUTSIZE/2-1);
				
				//printf("x = %d, y = %d, i = %d, j = %d\n",x,y,i,j);
				//system("pause");
				
				if(is_good_block(tab,i,j) == TRUE)
				{
					//printf("Bon bloc\n\n");
					b = randbit();
					if(b==0)
					{
						tab[i*AUTSIZE+j] = WEST;
						tab[i*AUTSIZE+j+1] = WEST;
						tab[(i+1)*AUTSIZE+j] = EAST;
						tab[(i+1)*AUTSIZE+j+1] = EAST;
					}
					if(b==1)
					{
						tab[i*AUTSIZE+j] = SOUTH;
						tab[i*AUTSIZE+j+1] = NORTH;
						tab[(i+1)*AUTSIZE+j] = SOUTH;
						tab[(i+1)*AUTSIZE+j+1] = NORTH;
					}
				}
			}
		}
	}
}

void creer_images(int MAX, int nbpix)
{
    int i,j,k,nb_img;
    int nb_mortes;
    
    char filename[30];
    
    char tab[AUTSIZE*AUTSIZE];
    char result[AUTSIZE*AUTSIZE];
    
	char img[LARGEUR_IMAGE*LARGEUR_IMAGE];
    
    // Initialisation de l'automate cellulaire
    
    for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			tab[i*AUTSIZE+j] = VIDE;
		}
	}
	
	tab[(AUTSIZE/2-1)*AUTSIZE+(AUTSIZE/2)-1] = WEST;
	tab[(AUTSIZE/2-1)*AUTSIZE+(AUTSIZE/2)] = WEST;
	
	tab[(AUTSIZE/2)*AUTSIZE+(AUTSIZE/2)-1] = EAST;
	tab[(AUTSIZE/2)*AUTSIZE+(AUTSIZE/2)] = EAST;
	
	nb_img = 0;
	
	*filename = 0;
    sprintf(filename, "aztec%.3d.bmp", nb_img);
    
    // On cre la premire image
    
    dessiner_tableau(img, tab, nbpix);
	ecrireFichier(filename,img, LARGEUR_IMAGE, LARGEUR_IMAGE);
    
    for(i = 1; i <= MAX; i++)
    {
    	// C'est la boucle des gnrations
        
        initialise(result);
        
        // Destruction
		destroy(result,tab);
		
        // Glissage
		
		slide(result,tab);
		remplace(result,tab);
		
		//Ci-dessous, en commentaire, le code pour faire des images intermdiaires
		
		/*
		// Rglage du nom du fichier
		
		nb_img++;
    	
        sprintf(filename, "aztec%.3d.bmp", nb_img);
		
		// Dessin aprs glissage
		
		dessiner_tableau(img, tab, nbpix);
		ecrireFichier(filename,img, LARGEUR_IMAGE, LARGEUR_IMAGE);
		*/
		
		// Remplissage des trous
		
		nb_mortes = 1;
		
		printf("On en est a la generation %d\n\n\n", i);
		//system("pause");
		
		while(nb_mortes != 0)
		{
			// autant de fois que ncessaire, on comble les trous
			
			nb_img++;
			
			sprintf(filename, "aztec%.3d.bmp", nb_img);	
			
          	create_good_block(tab,i);
          	
          	// et on dessine l'image
          	
          	dessiner_tableau(img, tab, nbpix);
			ecrireFichier(filename,img, LARGEUR_IMAGE, LARGEUR_IMAGE);
			
			// on va compter les mortes restantes
			
			nb_mortes = 0;
			
			for(j=0;j<AUTSIZE;j++)
			{
				for(k=0;k<AUTSIZE;k++)
				{
					if(tab[j*AUTSIZE+k] == DEAD)
					{
						nb_mortes++;
					}
				}
			}
			//printf("\n Nombre de mortes : %d\n",nb_mortes);
			//system("pause");
		}
		
		//printf("\n\n\n");	
    }
}




// GRAPHISME











char traduc_cardi_color(char point)
{
	if(point == VIDE)
	return BLANC;
	
	if(point == WEST)
	return ROUGE;
	
	if(point == EAST)
	return JAUNE;
	
	if(point == NORTH)
	return BLEU;
	
	if(point == SOUTH)
	return VERT;
	
	if(point == DEAD)
	return NOIR;
}

void dessiner_carre(char img[LARGEUR_IMAGE*LARGEUR_IMAGE], char color, int i, int j, int nbpix)
{
	int k,l;
	
	for(k=i;k<i+nbpix;k++)
	{
		for(l=j;l<j+nbpix;l++)
		{
			img[k*LARGEUR_IMAGE+l] = color;
		}
	}
}

void dessiner_tableau(char img[LARGEUR_IMAGE*LARGEUR_IMAGE], char tab[AUTSIZE*AUTSIZE], int nbpix)
{
	int i,j;
	
	// on commence par remplir de blanc
	
	for(i=0;i<LARGEUR_IMAGE;i++)
	{
		for(j=0;j<LARGEUR_IMAGE;j++)
		{
			img[i*LARGEUR_IMAGE+j] = BLANC;
		}
	}
	
	// cellule par cellule, on dessine un carr de la bonne taille et de la bonne couleur
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			dessiner_carre(img,traduc_cardi_color(tab[i*AUTSIZE+j]),TAILLE_IMAGE + (i - AUTSIZE/2)*nbpix, TAILLE_IMAGE + (j - AUTSIZE/2)*nbpix, nbpix);
		}
	}
}

/*
#define ROUGE 3
#define VERT 5
#define JAUNE 7
#define BLEU 9
#define BLANC 11
#define NOIR 25
*/

void ecrireFichier(const char nomFic[], const char tab[], \
                   unsigned long largeur, unsigned long hauteur)
{
  FILE * fic = fopen(nomFic, "wb");
  unsigned long monLong;
  unsigned short monShort;
  unsigned char monChar, i;
  unsigned long padding, ligne, colonne, index;

  char format[] = {'B', 'M'};
  unsigned long tailleFic = 54 + largeur*hauteur*3;

  
  fwrite(format, sizeof(char), 2, fic);

  /* size of the file in bytes */
  fwrite(&tailleFic, sizeof(unsigned long), 1, fic);

  /* Unused, app specific */
  monShort = 0;
  fwrite(&monShort, sizeof(unsigned short), 1, fic);
  fwrite(&monShort, sizeof(unsigned short), 1, fic);

  /* Offset for pixel data */
  monLong = 54;
  fwrite(&monLong, sizeof(unsigned long), 1, fic);

  /* Nb of bytes in the header from this point */
  monLong = 40;
  fwrite(&monLong, sizeof(unsigned long), 1, fic);

  fwrite(&largeur, sizeof(unsigned long), 1, fic);
  fwrite(&hauteur, sizeof(unsigned long), 1, fic);

  /* Nb of color planes (always 1) */
  monShort = 1;
  fwrite(&monShort, sizeof(unsigned short), 1, fic);

  /* Nb of bits per pixel */
  monShort = 24;
  fwrite(&monShort, sizeof(unsigned short), 1, fic);
  
  /* Compression mode */
  monLong = 0;
  fwrite(&monLong, sizeof(unsigned long), 1, fic);


  /* Size of the raw BMP data (after this header), including padding */
  if( (3*largeur)%4 == 0) padding = 0;
  else padding = 4 - ((3*largeur)%4);
  monLong = (largeur*3 + padding)*hauteur;
  fwrite(&monLong, sizeof(unsigned long), 1, fic);


  /* Horiz and vertic resolutions (pixel per metre) */
  monLong = 2835;
  fwrite(&monLong, sizeof(unsigned long), 1, fic);
  fwrite(&monLong, sizeof(unsigned long), 1, fic);


  /* Numbers of colors in the palette & number of important colors */ 
  monLong = 0;
  fwrite(&monLong, sizeof(unsigned long), 1, fic);
  fwrite(&monLong, sizeof(unsigned long), 1, fic);
 

  /* Pixel data */
  
  for(ligne = 0; ligne < hauteur; ligne ++)
    {
      for (colonne = 0; colonne < largeur; colonne ++)
        {
          index = largeur*colonne + ligne;
          /*
          fwrite(&tab[index], sizeof(char), 1, fic);
          fwrite(&tab[index], sizeof(char), 1, fic);
          fwrite(&tab[index], sizeof(char), 1, fic);
          */
          
          // ma petite tambouille pour les couleurs
          
	        if(tab[index] == BLANC)
			{
				monChar = 255;
			  	fwrite(&monChar, sizeof(char), 1, fic);
				fwrite(&monChar, sizeof(char), 1, fic);
				fwrite(&monChar, sizeof(char), 1, fic);
			}
	          
	        if(tab[index] == ROUGE)
	        {
	        	monChar = 34;
	          	fwrite(&monChar, sizeof(char), 1, fic);
	          	monChar = 22;
				fwrite(&monChar, sizeof(char), 1, fic);
	          	monChar = 199;
				fwrite(&monChar, sizeof(char), 1, fic);
	        }
	        
	        if(tab[index] == BLEU)
	        {
	        	monChar = 199;
	          	fwrite(&monChar, sizeof(char), 1, fic);
	          	monChar = 110;
	          	fwrite(&monChar, sizeof(char), 1, fic);
	          	monChar = 22;
	          	fwrite(&monChar, sizeof(char), 1, fic);
	        }
	        
	        if(tab[index] == JAUNE)
	        {
	        	monChar = 1;
	          	fwrite(&monChar, sizeof(char), 1, fic);
	          	monChar = 246;
	          	fwrite(&monChar, sizeof(char), 1, fic);
	          	monChar = 254;
	          	fwrite(&monChar, sizeof(char), 1, fic);
	        }
	        
	        if(tab[index] == VERT)
	        {
	        	monChar = 14;
	          	fwrite(&monChar, sizeof(char), 1, fic);
	          	monChar = 203;
	          	fwrite(&monChar, sizeof(char), 1, fic);
	          	monChar = 8;
	          	fwrite(&monChar, sizeof(char), 1, fic);
	        }
	        
	        if(tab[index] == NOIR)
			{
				monChar = 0;
			  	fwrite(&monChar, sizeof(char), 1, fic);
				fwrite(&monChar, sizeof(char), 1, fic);
				fwrite(&monChar, sizeof(char), 1, fic);
			}
          
        }

      /* Padding for 4 byte alignment */
      if( (3*largeur)%4 == 0) padding = 0;
      else padding = 4 - ((3*largeur)%4);
      monChar = 0;
      for (i = 0; i < padding; i++) fwrite(&monChar, sizeof(char), 1, fic);
    }

  fclose(fic);
}

/*
void creer_images(int MAX, real debut)
{
    float t;
    char tab[(LARGEUR_IMAGE)*(LARGEUR_IMAGE)];
    int i;
    
    char filename[30];
    
    for(i = 0; i <= MAX; i++)
    {
          t = i/(float)(MAX);
          
          *filename = 0;
          sprintf(filename, "cercle-gauss%.3d.bmp", i);
          
          setOrbitalfunction(tab, debut + t);
          
          ecrireFichier(filename, tab, LARGEUR_IMAGE, LARGEUR_IMAGE);
    }
}
*/
	
int main(void)
{
	/*
	char tab[AUTSIZE*AUTSIZE];
	char img[LARGEUR_IMAGE*LARGEUR_IMAGE];
	int i,j;
	
	for(i=0;i<AUTSIZE;i++)
	{
		for(j=0;j<AUTSIZE;j++)
		{
			tab[i*AUTSIZE+j] = VIDE;
		}
	}
	
	
	tab[7*AUTSIZE+6] = SOUTH;
	tab[7*AUTSIZE+7] = EAST;
	tab[7*AUTSIZE+8] = EAST;
	tab[7*AUTSIZE+9] = NORTH;
	
	tab[8*AUTSIZE+6] = SOUTH;
	tab[8*AUTSIZE+7] = WEST;
	tab[8*AUTSIZE+8] = WEST;
	tab[8*AUTSIZE+9] = NORTH;
	
	
	tab[7*AUTSIZE+7] = WEST;
	tab[7*AUTSIZE+8] = WEST;
	
	tab[8*AUTSIZE+7] = EAST;
	tab[8*AUTSIZE+8] = EAST;

	dessiner_tableau(img, tab, 12);
	ecrireFichier("aztec_test5.bmp",img, LARGEUR_IMAGE, LARGEUR_IMAGE);
	
	// premire gnration
	
	destroy_slide(tab);
	
	dessiner_tableau(img, tab, 12);
	ecrireFichier("aztec_test6.bmp",img, LARGEUR_IMAGE, LARGEUR_IMAGE);
	
	create_good_block(tab,1);
	
	dessiner_tableau(img, tab, 12);
	ecrireFichier("aztec_test7.bmp",img, LARGEUR_IMAGE, LARGEUR_IMAGE);
	
	// deuxime gnration
	
	destroy_slide(tab);
	
	dessiner_tableau(img, tab, 12);
	ecrireFichier("aztec_test8.bmp",img, LARGEUR_IMAGE, LARGEUR_IMAGE);
	
	create_good_block(tab,2);
	create_good_block(tab,2);
	
	dessiner_tableau(img, tab, 12);
	ecrireFichier("aztec_test9.bmp",img, LARGEUR_IMAGE, LARGEUR_IMAGE);

	// troisime gnration
	
	destroy_slide(tab);
	
	dessiner_tableau(img, tab, 12);
	ecrireFichier("aztec_test99.bmp",img, LARGEUR_IMAGE, LARGEUR_IMAGE);
	
	create_good_block(tab,3);
	create_good_block(tab,3);
	create_good_block(tab,3);
	create_good_block(tab,3);
	create_good_block(tab,3);
	create_good_block(tab,3);
	
	dessiner_tableau(img, tab, 12);
	ecrireFichier("aztec_test999.bmp",img, LARGEUR_IMAGE, LARGEUR_IMAGE);
	*/
	
	creer_images(100,5);
	
	return 0;
}
